aboutsummaryrefslogtreecommitdiffstats
path: root/package/network/utils/uqmi
diff options
context:
space:
mode:
authorFelix Fietkau <nbd@openwrt.org>2014-10-02 12:18:28 +0000
committerFelix Fietkau <nbd@openwrt.org>2014-10-02 12:18:28 +0000
commitb003339cfbf10be7000a683e70da3ac8e478de96 (patch)
tree0829d58640232ad6e7f8113ce95f889809c6d90c /package/network/utils/uqmi
parent33a1027ab97f9dfde48da533ad8388ee3f79890b (diff)
downloadmaster-187ad058-b003339cfbf10be7000a683e70da3ac8e478de96.tar.gz
master-187ad058-b003339cfbf10be7000a683e70da3ac8e478de96.tar.bz2
master-187ad058-b003339cfbf10be7000a683e70da3ac8e478de96.zip
uqmi: work out the ifname instead of relying on it being in uci
Signed-off-by: John Crispin <blogic@openwrt.org> git-svn-id: svn://svn.openwrt.org/openwrt/trunk@42719 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'package/network/utils/uqmi')
-rwxr-xr-xpackage/network/utils/uqmi/files/lib/netifd/proto/qmi.sh14
1 files changed, 13 insertions, 1 deletions
diff --git a/package/network/utils/uqmi/files/lib/netifd/proto/qmi.sh b/package/network/utils/uqmi/files/lib/netifd/proto/qmi.sh
index 693fd6c115..ce86dfce74 100755
--- a/package/network/utils/uqmi/files/lib/netifd/proto/qmi.sh
+++ b/package/network/utils/uqmi/files/lib/netifd/proto/qmi.sh
@@ -5,6 +5,8 @@
init_proto "$@"
proto_qmi_init_config() {
+ available=1
+ no_device=1
proto_config_add_string "device:device"
proto_config_add_string apn
proto_config_add_string auth
@@ -34,6 +36,16 @@ proto_qmi_setup() {
return 1
}
+ devname="$(basename "$device")"
+ devpath="$(readlink -f /sys/class/usbmisc/$devname/device/)"
+ ifname="$( ls "$devpath"/net )"
+ [ -n "$ifname" ] || {
+ logger -p daemon.err -t "qmi[$$]" "The interface could not be found."
+ proto_notify_error "$interface" NO_IFACE
+ proto_block_restart "$interface"
+ return 1
+ }
+
[ -n "$delay" ] && sleep "$delay"
while uqmi -s -d "$device" --get-pin-status | grep '"UIM uninitialized"' > /dev/null; do
@@ -93,7 +105,7 @@ proto_qmi_setup() {
fi
logger -p daemon.info -t "qmi[$$]" "Connected, starting DHCP"
- proto_init_update "*" 1
+ proto_init_update "$ifname" 1
proto_send_update "$interface"
json_init